<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on September 3, 2008 at 10:55:25 am</time-stamp>
<!-- Package Changes for PV-NM-Inventory-Application(Green.3,sourcecontrol)* -->


<methods>
<class-id>PROVISO.PvInventoryPropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForInventory: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>

<class>
<name>PvQCF5620PropertyManager</name>
<environment>PROVISO</environment>
<super>PROVISO.PvInventoryPropertyManager</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>PV-DM-Managers</category>
<attributes>
<package>PV-NM-Inventory-Application</package>
</attributes>
</class>

<methods>
<class-id>PROVISO.PvQCF5620PropertyManager</class-id> <category>database queries - private</category>

<body package="PV-NM-Inventory-Application" selector="dbResyncItems:between:and:">dbResyncItems: collectors between: startSeconds and: endSeconds 
 
	| params |
	params := Dictionary new
		at: #collectors put: collectors;
		at: #startSeconds put: startSeconds;
		at: #endSeconds put: endSeconds;
		yourself.
	(self 
		sqlStatementFor: (self itemClass selectStatementWithParametersForQCF5620: params)
		instanceClass: self itemClass) 
			do: [ :each | self resyncFrom: each]</body>
</methods>
<!-- Package Changes for PV-QCF-5620-Application(Green.1,mkamath)* -->


<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-QCF-5620-Application" selector="initializeForQCF5620">initializeForQCF5620
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvQCF5620PropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>

<methods>
<class-id>PROVISO.PvProperty class</class-id> <category>database support</category>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForInventory:">selectStatementWithParametersForInventory: parametersDictionary 
	"self dbSession execute: 
		(self 
		selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 
				' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' ']
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '].
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT /*+ NO_MERGE(VIEW1) USE_NL(VIEW1 t1)  ORDERED */ 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>

<body package="PV-QCF-5620-Application" selector="selectStatementWithParametersForQCF5620:">selectStatementWithParametersForQCF5620: parametersDictionary 
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 0 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"(self selectStatementWithParametersForQCF5620: (Dictionary withKeysAndValues: #(startSeconds 12123123 #endSeconds 1028821796 #collectors #(1 2 3 4 5 6))))"
	"This is the most generic select statement builder in our system.  In order to consolidate the entry point, we will encode special values for building different sql statements.
		If parametersDictionary doesn't include collectorList then we are selecting for all collectors
		if parametersDictionary doesn't include startSeconds, then we are doing a before date select"
	
	| realStartSeconds namedReplacements startSeconds endSeconds collectors |
	startSeconds := 
		parametersDictionary 
			at: #startSeconds
			ifAbsent: [0].
	endSeconds := 
		parametersDictionary 
			at: #endSeconds
			ifAbsent: [self timeFacade now asSeconds].
	collectors := 
		parametersDictionary 
			at: #collectors
			ifAbsent: [nil].
	realStartSeconds := 
		self lastResyncDate isNil 
			ifTrue: [startSeconds]
			ifFalse: [self lastResyncDate + 1].
	namedReplacements := Dictionary new.
	namedReplacements at: 'TABLE' put: self historyTableName asString.
	namedReplacements at: 'ELEMENTHISTORYTABLE' put: PvElement historyTableName asString.
	namedReplacements at: 'SUBELEMENTHISTORYTABLE' put: 
		PvSubelement historyTableName asString.
	startSeconds &gt; 0 
		ifTrue: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: 	' BETWEEN ' , realStartSeconds asString , ' AND ' , endSeconds asString , ' '.
			namedReplacements at: 'HINT' put: ' /*+ NO_MERGE(VIEW1) USE_NL(VIEW1 t1)  ORDERED */ '.]
		ifFalse: 
			[namedReplacements at: 'PRIMARYDATECONDITION' put: ' &lt; ' , endSeconds asString , ' '.
			namedReplacements at: 'HINT' put: ' /*+ NO_MERGE(VIEW1) USE_HASH(VIEW1 t1) ORDERED PUSH_SUBQ ALL_ROWS */ '.].
	namedReplacements at: 'SUBQUERYDATECONDITION' put: ' &lt;= ' , endSeconds asString.
	self isHistorical 
		ifTrue: 
			[namedReplacements at: 'COLUMNLIST' put: 
				(self allHistoricalColumnsForSelectWithPrefix: 't1.')]
		ifFalse: 
			[namedReplacements at: 'COLUMNLIST' put: (self allColumnsForSelectWithPrefix: 't1.')].
	(self isFilteredByCollector and: [collectors notNil]) 
		ifTrue: 
			[namedReplacements 
				at: 'COLLECTORCLAUSE'
				put: 
					'e.int_collector IN ' , (self inStatementForCollectors: collectors) asString , 
						' AND ']
		ifFalse: [namedReplacements at: 'COLLECTORCLAUSE' put: ' '].
	^'SELECT %HINT 
		%COLUMNLIST 
	FROM (
			SELECT /*+ push_subq */
				E.idx_ind as idx_ind
			FROM %ELEMENTHISTORYTABLE E
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
			UNION ALL
			SELECT /*+ push_subq use_nl(e, se)  */ 
				se.idx_ind as idx_ind
			FROM
				%ELEMENTHISTORYTABLE E,
				%SUBELEMENTHISTORYTABLE SE 
			WHERE %COLLECTORCLAUSE
				E.DTE_DATE = ( SELECT MAX(E1.DTE_DATE)
									FROM %ELEMENTHISTORYTABLE E1
									WHERE E1.IDX_IND = E.IDX_IND
										AND E1.DTE_DATE %SUBQUERYDATECONDITION)
				AND E.STR_ACTION IN (''I'', ''U'')
				AND E.IDX_IND &gt;= -1E10
				AND E.IDX_IND = SE.IDX_HOST
				AND SE.DTE_DATE = ( SELECT MAX(SE1.DTE_DATE)
									FROM %SUBELEMENTHISTORYTABLE SE1
									WHERE SE1.IDX_IND = SE.IDX_IND
										AND SE1.IDX_HOST = SE.IDX_HOST
										AND SE1.DTE_DATE %SUBQUERYDATECONDITION)
				AND SE.STR_ACTION IN (''I'', ''U'')   ) VIEW1,
		%TABLE t1
	WHERE view1.idx_ind = t1.idx_resource
		AND t1.DTE_HIST_DATE = ( SELECT MAX (t2.DTE_HIST_DATE)
									FROM %TABLE t2
									WHERE t1.IDX_METRIC = t2.IDX_METRIC
										AND t1.IDX_RESOURCE = t2.IDX_RESOURCE
										AND t2.DTE_HIST_DATE %PRIMARYDATECONDITION)
		AND t1.DTE_HIST_DATE %PRIMARYDATECONDITION ' namedBindWithArguments: 
			namedReplacements</body>
</methods>
<!-- Package Changes for PV-CWM-Application(Green.2,bbuxton)* -->


<methods>
<class-id>PROVISO.PvModel</class-id> <category>initialize-release</category>

<body package="PV-CWM-Application" selector="initializeForCWM">initializeForCWM
	
	self initOfflineIdManager.
	formulaManager := PvFormulaManager new.
	PROVISO.PvFormulas.PvCflFormula removeUserGeneratedCflFormulaClassess.
	elementManager := PvInventoryElementManager new.
	subelementManager := PvInventorySubelementManager new.
	requestManager := PvRequestManager new.
	thresholdManager := PvInventoryThresholdManager new.
	calendarManager := PvCalendarManager new.
	propertyManager := PvInventoryPropertyManager new.
	relationManager := PvInventoryRelationManager new.
	dataloadManager := PvDataloadManager new.
	profilesManager := PvProfilesManager new.
	snmpConfigurationManager := PvSnmpConfigurationManager new.
	self makeAllDomainManagersReferToMe.
	self initializeDebugCounters.
	self resyncAgent: (PvModelResyncAgent new pvModel: self; bufferActions: false; yourself).
	self initCollectorsByChannel.
	self loadStatsCollector: false.
	self pvModel formulaManager shouldBuildSmalltalkFormulas: false.</body>
</methods>


</st-source>
